import { Account, AccountWithTransactions, App, Block, DispatchRequest, DispatchResponse, GetAppOptions, GetNodesOptions, Node, TransactionResponse } from '@pokt-foundation/pocketjs-types';
import { AbstractProvider } from './abstract-provider';
export declare class JsonRpcProvider implements AbstractProvider {
    private rpcUrl;
    private dispatchers;
    constructor({ rpcUrl, dispatchers, }: {
        rpcUrl: string;
        dispatchers?: string[];
    });
    private perform;
    getBalance(address: string | Promise<string>): Promise<bigint>;
    getTransactionCount(address: string | Promise<string>): Promise<number>;
    getType(address: string | Promise<string>): Promise<'node' | 'app' | 'account'>;
    sendTransaction(signerAddress: string | Promise<string>, signedTransaction: string | Promise<string>): Promise<TransactionResponse>;
    getBlock(blockNumber: number): Promise<Block>;
    getTransaction(transactionHash: string): Promise<TransactionResponse>;
    getBlockNumber(): Promise<number>;
    getNodes(getNodesOptions: GetNodesOptions): Promise<Node[]>;
    getNode(address: string | Promise<string>, GetNodeOptions: any): Promise<Node>;
    getApps(getAppOption: GetAppOptions): Promise<App[]>;
    getApp(address: string | Promise<string>, options: GetAppOptions): Promise<App>;
    getAccount(address: string | Promise<string>): Promise<Account>;
    getAccountWithTransactions(address: string | Promise<string>): Promise<AccountWithTransactions>;
    dispatch(request: DispatchRequest, options?: {
        retryAttempts?: number;
        rejectSelfSignedCertificates?: boolean;
        timeout?: number;
    }): Promise<DispatchResponse>;
    relay(request: any, rpcUrl: string, options?: {
        retryAttempts?: number;
        rejectSelfSignedCertificates?: boolean;
        timeout?: number;
    }): Promise<unknown>;
}
//# sourceMappingURL=json-rpc-provider.d.ts.map